
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ASP.NET Cache的一些总结分享_实用技巧 / iVAN</title>

    <meta name="description" content="ASP.NET Cache的一些总结分享_实用技巧 1.1.1 摘要 最近我们的系统面临着严峻性能瓶颈问题这是由于访问量增加客户端在同一时间请求增加这迫使我们要从两个方面解决这一问题增加硬件和提高系统的性能. 大家可以通过各种各样的方法去优化我们系统本篇博文将介绍通过Cache方法来优化系统的性能减轻系统的负担. 1.1.2 正文 不同位置的缓存 在Web应用程序中的使用缓存位置主要有客户端浏览器缓存.客户端和服务器中以及服务器端因此缓存可以分为以下几类 客户端缓存Client Caching 代理缓存Proxy Caching 反向代理缓存Re">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">ASP.NET Cache的一些总结分享_实用技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>1.1.1 摘要</strong> <br />最近我们的系统面临着严峻性能瓶颈问题这是由于访问量增加客户端在同一时间请求增加这迫使我们要从两个方面解决这一问题增加硬件和提高系统的性能。</p>
<p>大家可以通过各种各样的方法去优化我们系统本篇博文将介绍通过Cache方法来优化系统的性能减轻系统的负担。</p>
<p><strong>1.1.2 正文 <br /></strong><br /><strong>不同位置的缓存 <br /></strong><br />在Web应用程序中的使用缓存位置主要有客户端浏览器缓存、客户端和服务器中以及服务器端因此缓存可以分为以下几类</p>
<p>客户端缓存Client Caching <br />代理缓存Proxy Caching <br />反向代理缓存Reverse Proxy Caching <br />服务器缓存Web Server Caching <br />ASP.NET中的缓存 <br />ASP.NET中有两种缓存类型输出缓存和数据缓存。</p>
<p>输出缓存这是最简单的缓存类型它保存发送到客户端的页面副本当下一个客户端发送相同的页面请求时此页面不会重新生成在缓存有限期内而是从缓存中获取该页面当然由于缓存过期或被回收这时页面会重新生成。</p>
<p><strong>数据缓存 <br /></strong><br />除此之外还有两个特殊的缓存片段缓存和数据源缓存。</p>
<p>片段缓存这是一种特殊的输出缓存它不是缓存整个页面而是缓存部分页面由于缓存整个页面通常并不可行因为页面的某些部分是针对用户定制的例如用户登陆信息但我们可以把应用程序中共享的部分进行缓存这时我们可以考虑使用片段缓存和用户控件缓存。</p>
<p>数据源缓存是建立在数据源控件的缓存它包括SqlDataSource、ObjectDataSource和XmlDataSource控件。数据源缓存使用数据缓存方式不同的是我们不需要通过显示方法处理缓存我们只需设置相应的属性然后数据源控件就能存储和检索数据。</p>
<p><strong>输出缓存</strong> <br />输出缓存可以把最终呈现的页面缓存起来当客户端再次请求同一页面时控制对象不再重新创建页面的生命周期不再启动无需再次执行代码通过在缓存中获取缓存的页面。</p>
<p>现在我们设计一个页面每当用户发送页面请求时就获取当前代码执行的时间然后显示在页面上。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMDgwMjExMzkyMzIucG5n.jpg"></p>
<p><strong>图1输出缓存 <br /></strong><br />这是再简单不过的例子每当用户发送页面请求都会更新页面显示的时间这是由于每次请求都获取了一个新的页面实际情况中我们并不需要实时的响应用户每个页面请求我们可以通过输出缓存把页面缓存起来每当用户发送同一页面请求时而且在缓存有效期间可以通过输出缓存把缓存的页面返回给用户。</p>
<p>我们要实现输出缓存只需在页面中添加如下代码</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;!-- Adds OutputCache directive --&gt; <br />&lt;%@ OutputCache Duration="23" VaryByParam="None" %&gt;</p>
<p>它支持五个属性其中两个属性Duration和VaryByParam是必填的 <br />
<table>
<tbody>
<tr>
<td>
<br />Duration</p>
</td>
<td>
<br />必需属性。页面应该被缓存的时间以秒为单位。必须是正整数。</p>
</td>
</tr>
<tr>
<td>
<br />Location</p>
</td>
<td>
<br />指定应该对输出进行缓存的位置。如果要指定该参数则必须是下列选项之一Any、Client、Downstream、None、Server 或 ServerAndClient。</p>
</td>
</tr>
<tr>
<td>
<br />VaryByParam</p>
</td>
<td>
<br />必需属性。Request 中变量的名称这些变量名应该产生单独的缓存条目。"none" 表示没有变动。"*" 可用于为每个不同的变量数组创建新的缓存条目。变量之间用 ";" 进行分隔。</p>
</td>
</tr>
<tr>
<td>
<br />VaryByHeader</p>
</td>
<td>
<br />基于指定的标头中的变动改变缓存条目。</p>
</td>
</tr>
<tr>
<td>
<br />VaryByCustom</p>
</td>
<td>
<br />允许在 global.asax 中指定自定义变动例如"Browser"。</p>
</td>
</tr>
</tbody>
</table>
<p>表1输出缓存属性</p>
<p>这里我们把输出缓存的有效期设置为23秒也就是说当缓存超过有效期就会被回收当用户再次请求该页面时就要重新创建页面。</p>
<p><strong>客户端缓存</strong> <br />另一种选择是客户端缓存如果用户在浏览器中点击“后退”按钮或在地址栏中重新输入URL那么在这种情况下浏览器将从缓存获取页面然而如果用户点击“刷新”按钮那么浏览器中缓存将失效浏览器发送页面请求。</p>
<p>如果我们要使用客户端缓存只需指定OutputCache中的属性Location=”Client”就OK了具体代码如下所示</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;!-- Sets client OutputCache --&gt; <br />&lt;%@ OutputCache Duration="23" VaryByParam="None" Location="Client" %&gt;</p>
<p>通过在OutputCache中添加Location属性我们实现了客户端缓存通过设置客户端缓存我们能够减少的客户端请求也许有人会问“每个用户第一次页面请求都需要服务器来完成这不能很好的减少服务的压力”。的确是这样相对于服务器缓存客户端缓存并没有减少代码的执行和数据库的操作但是当我们把包含个性化数据的页面缓存在服务器中客户端请求页面时由于不同的用户个性化数据不同这将会导致请求出现错误所以我们可以使用片段缓存把公用的部分缓存起来或客户端缓存把用户信息缓存起来。</p>
<p><strong>Query String缓存</strong> <br />在前面的例子中我们把OutputCache中的VaryByParam属性设置为None那么ASP.NET程序只缓存一个页面副本如果页面请求包含查询参数那么在缓存的有效期内我们只可以查看到只是缓存结果假设我们有个报表程序它提供用户根据产品名称查询相关的产品信息。</p>
<p>首先我们创建两个页面查询和结果页面由于时间关系我们已经把页面设计好了具体如下所示</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMDgwMjExMzkyMzMucG5n.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMDgwMjExMzkyMzQucG5n.jpg"></p>
<p>图2报表程序</p>
<p>首先我们提供查询页面让用户根据成品名称ProductName查询相应的成品信息具体的代码如下</p>
<p><u>复制代码</u> 代码如下:</p>
<p>protected void Page_Load(object sender, EventArgs e) <br />{ <br />if (!Page.IsPostBack) <br />{ <br />// Gets product id from table Production.Product. <br />// Then binding data to drop down list control. <br />InitControl(GetProductId()); <br />} <br />} <br />/// &lt;summary&gt; <br />/// Handles the Click event of the btnSubmit control. <br />/// Redirects to relative product information page. <br />/// &lt;/summary&gt; <br />protected void btnSubmit_Click(object sender, EventArgs e) <br />{ <br />Response.Redirect(string.Format("Product.aspx?productname={0}", ddlProductName.SelectedValue)); <br />}</p>
<p>当用户点击Submit按钮后跳转到Product页面并且在Url中传递查询参数——产品名称ProducName。</p>
<p>接下来我们继续完成查询页面由于在前一页面中传递了查询参数ProductName那么我们将根据ProductName查询数据库获取相应的产品信息具体代码如下所示</p>
<p><u>复制代码</u> 代码如下:</p>
<p>protected void Page_Load(object sender, EventArgs e) <br />{ <br />// Get product name. <br />string productName = Request.QueryString["productname"];</p>
<p>// Binding data to data grid view control. <br />InitControl(this.GetData(productName)); <br />}</p>
<p>/// &lt;summary&gt; <br />/// Inits the control. <br />/// &lt;/summary&gt; <br />/// &lt;param name="ds"&gt;The dataset.&lt;/param&gt; <br />private void InitControl(DataSet ds) <br />{ <br />dgvProduct.DataSource = ds; <br />dgvProduct.DataBind(); <br />}</p>
<p>/// &lt;summary&gt; <br />/// Gets the data. <br />/// &lt;/summary&gt; <br />/// &lt;param name="productName"&gt;Name of the product.&lt;/param&gt; <br />/// &lt;returns&gt;Returns dataset&lt;/returns&gt; <br />private DataSet GetData(string productName) <br />{ <br />// The query sql base on product name. <br />string sql = <br />string.Format( <br />"SELECT Name, ProductNumber, SafetyStockLevel, ReorderPoint, StandardCost, DaysToManufacture " <br />+ "FROM Production.Product WHERE ProductNumber='{0}'", <br />productName);</p>
<p>// Get data from table Production.Product. <br />using (var con = new SqlConnection(ConfigurationManager.ConnectionStrings["SQLCONN"].ToString())) <br />using (var com = new SqlCommand(sql, con)) <br />{ <br />com.Connection.Open(); <br />////gdvData.DataSource = com.ExecuteReader(); <br />////gdvData.DataBind(); <br />var ada = new SqlDataAdapter(com); <br />var ds = new DataSet(); <br />ada.Fill(ds); <br />return ds; <br />} <br />}</p>
<p>前面示例我们通过Request的属性QueryString获取ProductName的值然后根据ProductName查询数据库最后把获取数据绑定到Datagridview控件中注前面实例没有考虑SQL Injection问题。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMDgwMjExMzkyMzUucG5n.jpg"></p>
<p>图3查询结果</p>
<p>现在我们在页面中添加输出缓存如下代码</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;!-- Adds OutputCache directive --&gt; <br />&lt;%@ OutputCache Duration="30" VaryByParam="None" %&gt;</p>
<p>前面提到当输出缓存的属性VaryByParam=”None”时ASP.NET程序在缓存有效期内只缓存一个页面副本现在我们在缓存有效期内30s再发送请求。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMDgwMjExMzkyMzYucG5n.jpg"></p>
<p>图4查询结果</p>
<p>通过上图我们发现现在查询参数ProductName=BK-M18B-40但查询结果依然是ProductName=BB-9108的数据这是由于ASP.NET程序在缓存有效期内只缓存一个页面副本。</p>
<p>通过上面的示例我们发现只缓存一个页面是不适用包含查询参数的页面输出缓存其实前面的示例我们只需稍稍改动就能符合查询参数的情况了想必大家已经知道了只需把VaryByParam属性设置为“*”就OK了。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMDgwMjExMzkyMzcucG5n.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMDgwMjExMzkyMzgucG5n.jpg"></p>
<p>图5查询结果</p>
<p>现在查询可以获取相应的结果如果查询参数和前一个请求相同并且该页面缓存有效那么缓存将被重用否则创建一个新的页面缓存。</p>
<p>由于ASP.NET给每个查询参数都添加了输出缓存但我们要注意的是是否真的有必要缓存每个查询参数都缓存一个页面副本假设查询Url中增加一个参数参数ProductId那么现在Url中就有两个查询参数了ProductName和ProductId。</p>
<p>前面我们把VaryByParam设置为“*”所为ASP.NET程序对ProductName和ProductId都创建页面缓存如果我们只针对ProductName创建页面缓存这时我们可以修改VaryByParam具体如下所示</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;!-- Sets VaryByParam property--&gt; <br />&lt;%@ OutputCache Duration="30" VaryByParam="productname" %&gt;</p>
<p>自定义缓存控件 <br />前面我们介绍了通过查询参数实现缓存一个或多个页面其实ASP.NET也允许我们自定义缓存方式来决定是否缓存页或重用现有的这时我们可以通过设置VaryByCustom属性来实现。</p>
<p>假设现在我们要设计基于不同UserHostName的缓存由于程序在执行过程中首先调用全局方法GetVaryByCustomString()来确定是否缓存页面或重用现有的所以我们可以通过重写GetVaryByCustomString()方法实现基于UserHostName的缓存首先我们创建一个Global.asax文件然后重新全局方法GetVaryByCustomString()具体实现如下</p>
<p><u>复制代码</u> 代码如下:</p>
<p>/// &lt;summary&gt; <br />/// Gets vary cache based on custom string value. <br />/// &lt;/summary&gt; <br />/// &lt;param name="context"&gt;Http context.&lt;/param&gt; <br />/// &lt;param name="custom"&gt;custom string&lt;/param&gt; <br />/// &lt;returns&gt;&lt;/returns&gt; <br />public override string GetVaryByCustomString(HttpContext context, string custom) <br />{ <br />if (string.Equals(custom, "UserHostName", StringComparison.OrdinalIgnoreCase)) <br />{ <br />// Indicates that the cache should be vary on user host name. <br />return Context.Request.UserHostName; <br />} <br />return base.GetVaryByCustomString(context, custom); <br />}</p>
<p>前面我们重写了GetVaryByCustomString()方法使得UserHostName值不同时获取相应的缓存值。</p>
<p>然后让程序基于UserHostName创建缓存所以我们要在页面添加以下代码</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;!-- set vary cache based on custom string value --&gt; <br />&lt;%@ OutputCache Duration="30" VaryByParam="None" VaryByCustom="UserHostName" %&gt;</p>
<p>我们通过自定义现在GetVaryByCustomString()方法实现了Web程序根据UserHostName实施不同的缓存方式其实我们还可以实现更多种类缓存方案例如基于用户角色、时间和Url等等。</p>
<p>片段缓存 <br />在某些情况下我们不能缓存整个页面但我们仍想缓存部分页面从而减轻系统的负担其实我们可以通过两种方法实现片段缓存和数据缓存.</p>
<p>为了实现片段缓存我们需要创建自定义控件缓存部分页面然后我们把OutputCache指令添加到自定义控件中这样整个页面将不会被缓存而自定义缓存控件除外。</p>
<p>前面我们介绍了输出缓存的使用只需在页面中添加OutputCache指令假设我们要在几个页面中添加输出缓存这可能比较简单但我们要在几十个页面中添加输出缓存功能而且前面介绍的例子中Duration属性值都是直接Hard code到每个页面中如果我们需要修改Duration属性值那么就必须修改每个页面了ASP.NET还需要重新编译这些页面这不利于我们的维护最重要的是增加了我们的工作量。</p>
<p>其实我们可以在web.config文件中定义一个outputCacheProfileProductCacheProfile然后在页面中添加CacheProfile属性并且赋值为ProductCacheProfileweb.config文件设置如下</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;caching&gt; <br />&lt;!-- Sets out put cache profile--&gt; <br />&lt;outputCacheSettings&gt; <br />&lt;outputCacheProfiles&gt; <br />&lt;add name="ProductCacheProfile" duration="30"/&gt; <br />&lt;/outputCacheProfiles&gt; <br />&lt;/outputCacheSettings&gt; <br />&lt;/caching&gt;现在我们在页面中添加CacheProfile属性并且设置为ProductCacheProfile如下所示</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;!-- set CacheProfile property --&gt; <br />&lt;%@ OutputCache CacheProfile="ProductCacheProfile" VaryByParam="None" %&gt;</p>
<p>数据缓存 <br />Cache对象是线程安全这表示无需显式实现锁定或解锁在添删Cache对象中的元素然而在Cache对象中元素必须是线程安全的。例如我们创建一个实体Product而且存在多个客户端可能同时操作该对象的情况这时我们必须为实体Product实现锁定和解锁操作同步操作请参考《单例模式Singleton的6种实现》。</p>
<p>Cache对象中的缓存项自动移除当缓存过期依赖项被修改或内存不足缓存ASP.NET会自动移除该缓存项。</p>
<p>缓存项支持依赖关系我们可以给缓存项添加文件、数据库表或其他资源类型的依赖关系。</p>
<p>SqlDataSource缓存 <br />当我们在SqlDataSource控件中启用缓存它缓存SelectCommand中的结果如果SQL查询语句中带有参数时SqlDataSource控件会缓存每一个参数值对应的结果。</p>
<p>这跟我们之前通过输出缓存实现报表程序缓存查询页面效果一样所以我们将使用SqlDataSource缓存实现该效果。</p>
<p>假设我们要提供一个报表程序让用户通过选择产品名称ProductName获取相应的产品信息。</p>
<p>首先我们在页面中创建两个数据源控件sourceProductName和sourceProduct接着把数据源分别绑定到Dropdownlist和Gridview中具体实现如下</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;!-- The product number datasource START --&gt; <br />&lt;asp:SqlDataSource ID="sourceProductName" runat="server" ProviderName="System.Data.SqlClient" <br />EnableCaching="True" CacheDuration="3600" ConnectionString="&lt;%$ ConnectionStrings:SQLCONN %&gt;" <br />SelectCommand="SELECT ProductNumber FROM Production.Product"&gt;&lt;/asp:SqlDataSource&gt; <br />&lt;!-- The product number datasource END --&gt;</p>
<p>&lt;!-- The product datasource START --&gt; <br />&lt;asp:SqlDataSource ID="sourceProduct" runat="server" ProviderName="System.Data.SqlClient" <br />EnableCaching="True" CacheDuration="3600" ConnectionString="&lt;%$ ConnectionStrings:SQLCONN %&gt;" <br />SelectCommand="SELECT Name, ProductNumber, SafetyStockLevel, ReorderPoint, StandardCost, DaysToManufacture <br />FROM Production.Product WHERE ProductNumber=@ProductNumber"&gt; <br />&lt;SelectParameters&gt; <br />&lt;asp:ControlParameter ControlID="ddlProductNumber" Name="ProductNumber" PropertyName="SelectedValue" /&gt; <br />&lt;/SelectParameters&gt; <br />&lt;/asp:SqlDataSource&gt; <br />&lt;!-- The product number datasource END --&gt;</p>
<p>&lt;!-- Binding the product number to gridview control --&gt; <br />&lt;!-- NOTE: Due to search and result in the same page, so need to set AutoPostBack is True--&gt; <br />&lt;asp:DropDownList ID="ddlProductNumber" AutoPostBack="True" DataSourceID="sourceProductName" <br />DataTextField="ProductNumber" runat="server"&gt; <br />&lt;/asp:DropDownList&gt;</p>
<p>&lt;!-- Binding the product datasource to gridview control --&gt; <br />&lt;asp:GridView ID="gvProduct" runat="server" DataSourceID="sourceProduct" CssClass="Product"&gt; <br />&lt;/asp:GridView&gt;</p>
<p>现在我们对报表程序进行查询如果ProudctName之前没有被缓存起来就会创建相应的缓存而已经缓存起来的将被重用查询结果如下</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMDgwMjExMzkyMzkucG5n.jpg"><br />图6查询结果</p>
<p>缓存的依赖关系 <br />缓存项之间的依赖</p>
<p>ASP.NET Cache允许我们建立缓存之间的依赖关系即一个缓存项依赖于另一个缓存项以下示例代码创建了二个缓存项并且它们之间建立依赖关系。具体实现如下</p>
<p><u>复制代码</u> 代码如下:</p>
<p>// Creates cache object Key1. <br />Cache["Key1"] = "Cache Item 1";</p>
<p>// Makes Cache["Key2"] dependent on Cache["Key1"]. <br />string[] dependencyKey = new string[1]; <br />dependencyKey[0] = "Key1";</p>
<p>// Creates a CacheDependency object. <br />CacheDependency dependency = new CacheDependency(null, dependencyKey);</p>
<p>// Establishs dependency between cache Key1 and Key2. <br />Cache.Insert("Key2", "Cache Item 2", dependency);</p>
<p>现在当Key1缓存项更新或从缓存中删除Key2缓存项就会自动从缓存删除。</p>
<p><strong>文件依赖</strong></p>
<p>前面我们介绍了缓存项之间的依赖关系ASP.NET Cache还提供缓存项与文件之间的依赖关系当文件被更新或删除对应的缓存项也将失效。</p>
<p>在上篇博文《Ajax与JSON的一些总结》的最后介绍的一个DEMO——Weibo Feed中我们通过实时方式向新浪微博API发送请求获取相应的数据但在一定时间内请求的次数是有限制的一旦超出了限制次数就不再接受请求了具体请参考Rate-limiting。所以可以通过Cache的方式把数据缓存起来当客户端请求时如果缓存数据已经存在那么直接返回数据否则重新想微博API请求数据。</p>
<p>首先我们创建一个HttpHandler它负责向微博API发送请求并且把数据保存的文件中最后把数据返回的客户端。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMDgwMjExMzkyMzEwLnBuZw==.jpg"></p>
<p>图7 请求流程 <br />接下来我们定义CacheData()方法把微博数据保存到文本文件中并且建立缓存与数据文件的依赖关系。</p>
<p><u>复制代码</u> 代码如下:</p>
<p>/// &lt;summary&gt; <br />/// Caches the data into text file. <br />/// &lt;/summary&gt; <br />/// &lt;param name="context"&gt;The http context&lt;/param&gt; <br />private void CacheData(HttpContext context) <br />{ <br />// Weibo API. <br />string uri = context.Request.QueryString["api"] + "?" + <br />"source=" + context.Request.QueryString["source"] + "&amp;" + <br />"count=" + context.Request.QueryString["count"]; <br />HttpWebResponse response = this.GetWeibos(uri); <br />if (null == response) <br />{ <br />throw new ArgumentNullException("Response is null"); <br />} <br />string jsonData; <br />// Writes the reponse data into text file. <br />using (var reader = new StreamReader(response.GetResponseStream(), Encoding.GetEncoding(response.CharacterSet))) <br />{ <br />jsonData = reader.ReadToEnd(); <br />} <br />string dataPath = context.Server.MapPath("weibo.json"); <br />using (var writer = new StreamWriter(dataPath, false, Encoding.GetEncoding(response.CharacterSet))) <br />{ <br />writer.Write(jsonData); <br />} <br />// Establishs dependency between cache weibo and text file. <br />// Sets cache expires after 2 minuntes. <br />HttpRuntime.Cache.Insert("weibo", jsonData, Dep, Cache.NoAbsoluteExpiration, TimeSpan.FromMinutes(2)); <br />}</p>
<p>现在我们把数据保存到文本文件中并且建立了缓存weibo与数据文件的依赖关系接下来我们要把JSON格式数据返回给客户端。</p>
<p><u>复制代码</u> 代码如下:</p>
<p>/// &lt;summary&gt; <br />/// Responses the weibo data. <br />/// &lt;/summary&gt; <br />/// &lt;param name="context"&gt;The http contex.&lt;/param&gt; <br />private void ResponseWeibo(HttpContext context) <br />{ <br />// Gets the weibo cache data. <br />byte[] buf = Encoding.UTF8.GetBytes(HttpRuntime.Cache["weibo"].ToString()); <br />// Writes the data into output stream. <br />context.Response.OutputStream.Write(buf, 0, buf.Length); <br />context.Response.OutputStream.Flush(); <br />////context.Response.Close(); <br />}</p>
<p>上面我们把JSON格式字符串转换为Byte数值然后写入到OutputStream中最后把数据返回给客户端。</p>
<p><u>复制代码</u> 代码如下:</p>
<p>// The function to get weibo data. <br />loadWeibo: function() { <br />$.ajax({ <br />// Weibo API. <br />url: "WeiboHandler.ashx", <br />type: "GET", <br />// NOTE: We get the data from same domain, <br />// dataType is json. <br />dataType: "json", <br />data: { <br />source: JQWeibo.appKey, <br />count: JQWeibo.numWeibo <br />}, <br />// When the requet completed, then invokes success function. <br />success: function(data, textStatus, xhr) { <br />// Sets html structure. <br />var html = <br />'&lt;div class="weibo"&gt;' + <br />'&lt;a href="http://weibo.com/DOMAIN" target="_blank"&gt;USER&lt;/a&gt;' + <br />'WEIBO_TEXT&lt;div class="time"&gt;AGO&lt;/div&gt;'; <br />// Appends weibos into html page. <br />for (var i = 0; i &lt; data.length; i++) { <br />$(JQWeibo.appendTo).append( <br />html.replace('WEIBO_TEXT', JQWeibo.ify.clean(data[i].text)) <br />// Uses regex and declare DOMAIN as global, if found replace all. <br />.replace(/DOMAIN/g, data[i].user.domain) <br />.replace(/USER/g, data[i].user.screen_name) <br />.replace('AGO', JQWeibo.timeAgo(data[i].created_at)) <br />); <br />} <br />} <br />}) <br />}</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMDgwMjExMzkyMzExLnBuZw==.jpg">图8请求结果 <br /><strong>1.1.3 总结 <br /></strong>缓存可以使应用程序的性能得到很大的提高因此在设计应用程序应该予以考虑本博文主要介绍了ASP.NET中输出缓存和数据缓存的应用场合和区别。</p>
<p>页面缓存适用于生成的页面通常都相同或改变时间比较固定情况例如数据在每小时都会更新那么我们可以设置duration为3600s。</p>
<p>数据缓存适用生成的页面总是在变化情况。</p>
<p>http://www.codeproject.com/Articles/29899/Exploring-Caching-in-ASP-NET <br />http://msdn.microsoft.com/zh-cn/library/aa478965.aspx <br />http://www.amazon.com/Beginning-ASP-NET-3-5-2008-Professional/dp/1590598911</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 13:18:47</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/cache/" title="Cache">Cache</a>, <a href="https://www.iamivan.net/tag/asp-net/" title="asp&period;net">asp&period;net</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>ASP.NET Cache的一些总结分享_实用技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr21kxM.html" rel="bookmark">ASP&period;Net缓存总结及分析 分享&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.页面缓存        要实现页面输出缓存,只要将一条 OutputCache 指令添加到页面即可.         &lt;%@ OutputCache CacheProfile=&quot; &quot; NoStore=&quot;True | False&quot; Duration=&quot;#ofseconds&quot; Shared=&quot;True | False&quot; Location=&quot;Any | Client | Downstream | Server |			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGr3ekp.html" rel="bookmark">asp&period;net文件上传示例分享&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				方法一:用Web控件FileUpload,上传到网站根目录. Test.aspx关键代码: 复制代码 代码如下: &lt;form id=&quot;form1&quot; runat=&quot;server&quot;&gt;&lt;asp:FileUpload ID=&quot;FileUpload1&quot; runat=&quot;server&quot; /&gt;&lt;asp:Button ID=&quot;Button1&quot; runat=&quot;server&quot; T			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKqL5ap.html" rel="bookmark">ASP&period;NET餐饮管理系统制作代码分享&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				页面介绍展示: 以上是餐饮管理系统制作图片介绍,接下来是代码部分. menu.aspx ﻿ &lt;%@ Page Language=&quot;C#&quot; MasterPageFile=&quot;~/MasterPage.master&quot; AutoEventWireup=&quot;true&quot; CodeFile=&quot;menu.aspx.cs&quot; Inherits=&quot;menu&quot; Title=&quot;无标题页&quot; %&gt; &lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ1950b.html" rel="bookmark">asp&period;net错误页面处理示例分享&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.新建Golbal.asax 复制代码 代码如下: void Application_Error(object sender, EventArgs e) {    Exception objErr = Server.GetLastError().GetBaseException();    string error = &quot;发生异常页: &quot; + Request.Url.ToString() + &quot;&lt;br&gt;&quot;;    error += &quot;异常信息			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR1Y6qb.html" rel="bookmark">Asp&period;net 网站性能优化二则分享&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着后端优化空间越来越小,现在越来越多的网站更注重前端性能的优化,就是浏览器,http层面的优化,这里写两点最简单最有效的 asp.net网站优化技巧. 了解常见的网站性能优化技巧 首先我们要学一些优化网站性能和体验的理论和基础知识,雅虎已经帮我们总结好了,详见参考链接中的几篇文章,有好心人已经给翻译成中文了.这里面提到的一些技巧可操作性都很强,建议每一个网站开发人员都仔细学习并进行实践,可以说不了解这里面说的优化技巧,提升网站前端性能就无从谈起. 诊断网站性能 要想优化网站的前端性能,首先要查			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOnYjQp.html" rel="bookmark">asp&period;net连接数据库读取数据示例分享&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				webconfig配置: 复制代码 代码如下: &lt;connectionStrings&gt;  &lt;add name=&quot;MSSQL&quot; connectionString=&quot;Data Source=localhost;Initial Catalog=test;User ID=sa;password=sa;&quot; providerName=&quot;System.Data.SqlClient&quot;/&gt;&lt;/connectionStrings&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3Z5jJz.html" rel="bookmark">asp&period;net生成缩略图示例方法分享&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				做站的时候经常会遇到要生成缩略图的功能,因为可能不同的情况需要用来不同大小的缩略图. 本文生成的图片都为正方形,只有正方形的缩略图才是保证图片足够清晰. 当我我这里说的正方形是先按比例压缩,然后加一个固定的白底 然后居中显示. 代码: 新建outputimg.ashx 复制代码 代码如下: //调整图片大小private static Size NewSize(int maxWidth, int maxHeight, int Width, int Height)        {        			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXKLZ4M.html" rel="bookmark">asp&period;net导出Excel类库代码分享&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下: using System;using System.Collections.Generic;using System.Reflection;using System.Web;using Excel = Microsoft.Office.Interop.Excel; /// &lt;summary&gt;///ExcelClass 的摘要说明/// &lt;/summary&gt;public class ExcelClass{    /// &lt;summary&gt;    //			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1rmkKp.html" rel="bookmark">ASP动态网页制作技术经验分享&lowbar;应用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学好一门编程语言有两个条件是必不可少的,一是理论与实践结合.在实际例程去验证书本上的理论能加深你对理论的理解:二是学会总结,把学习.运用中的心得体会记下来,当成一种经验或者教训加以提炼并在日后的应用中加以改进,一定能提高你对这门编程语言的认识.以下是笔者在学习与运用ASP编程中的两点经验,希望能对大家有所帮助. ASP页面内VBScript和JScript的交互 ASP具备管理不同语言脚本程序的能力,能够自动调用合适的脚本引擎以解释脚本代码和执行内置函数.ASP开发环境提供了两种脚本引擎,即VB			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy5GPM.html" rel="bookmark" class="title">让网站内容被快速收录应注意的五点</a>
					<div>
						每一个做网站或是做SEO的人都知道,一个网站的成功与否是取决于网站的收录上的,网站的内容被搜索引擎很快的收录,是每一个建站人的心愿.但是,有的时候,我们写的东西放到网站上,却迟迟不见收录,这是为什么呢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqleab.html" rel="bookmark" class="title">浅谈如何从外链及友链引进流量</a>
					<div>
						一直都不懂&quot;内容为王,外链为皇&quot;是什么意思,刚开始建站收录出奇的好,也没有做过任何推广,没有什么友链,就很自然的网站流量就上去了.估计是因为当时百度的算法没有非常严格,让我侥幸过关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7dK8M.html" rel="bookmark" class="title">Windows XP揪出占据硬盘的凶手</a>
					<div>
						最近笔者给一朋友装机,新电脑搞回家后我就帮他装系统,现在当然首选Win XP了.在要给系统盘分区时,原以为一个XP系统安装完成后也就是占到不到2G的空间,给它分个4G就足够了.可没想到用了一段时间后他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBRrWb.html" rel="bookmark" class="title">在Java中使用VC&plus;&plus;组件</a>
					<div>
						介绍JNI是我喜欢的java编程框架:它让你你自由的使用本地编写的代码.例如,如果你想要在你的java程序中使用Windows API(不如说dll),那么你就要用JNI. Java最受欢迎的特性就是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3o74p.html" rel="bookmark" class="title">115网盘怎么接收礼包</a>
					<div>
						  1.打开你的115网盘,进入115网盘的礼包领取页面http://115.com/lb 2.在输入框中输入你的礼包的礼包码点击接受礼包 3.如果要你查看你的礼包可以&quot;点击查看&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8QxAp.html" rel="bookmark" class="title">c&plus;&plus;文件的输入输出&comma;怎么编写程序</a>
					<div>
						问题描述 c++文件的输入输出,怎么编写程序 编写程序,将abc.txt的内容复制到xyz.txt文件中. 不懂使用文件 呜 解决方案 编写程序 分别使用输入 输出 求平均值函数 解决方案二: //打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGNl6p.html" rel="bookmark" class="title">cpu和内存的关系</a>
					<div>
						CPU是负责运算和处理的,内存是交换数据的. 当程序或者操作者对CPU发出指令,这些指令和数据暂存在内存里,在CPU空闲时将数据传送给CPU,CPU处理后把结果输出到输出设备上,输出设备就是显示器,打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6DmBz.html" rel="bookmark" class="title">双十一：全网单日交易额（GMV）1229&period;37亿元人民币</a>
					<div>
						热闹的&quot;双11春晚&quot;扯着振奋的钟声拉开购物狂欢节的大幕,电商平台上的各项&quot;节目&quot;是否精彩十足,交出了完美的闭幕式呢?据星图数据统计,2015年11月11日,全网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoJ5Ob.html" rel="bookmark" class="title">apk反编译总结（看雪论坛）</a>
					<div>
						好吧,第一次在oschina写记录,以前自己博客的服务器没钱续费都给删了.算是重新开始吧. 之前一直在Ubuntu下反编译apk,今天因为有空,试了下在windows下反编译,在网上找的教程,mark ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRy26b.html" rel="bookmark" class="title">jvm-apache连接数过多时域名无法访问，ip访问tomcat应用正常</a>
					<div>
						问题描述 apache连接数过多时域名无法访问,ip访问tomcat应用正常 请教下大家: 我官网www域名解析到一台装有apache的服务器上,二级域名从apache转到tomcat服务器上. to ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZdYaz.html" rel="bookmark" class="title">linux系统中yunfile文件下载脚本</a>
					<div>
						脚本内存和CPU占用很低! 回答问题时我的脚本已经完成了60%,昨天凌晨加班完成了,使用到了ORC解析验证码,指定只分析数字! 使用前需要安装很多库,如果需要orc识别,还需要需要你的系统安装Tess ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94aWdb.html" rel="bookmark" class="title">有没免费网管软件公司有几台服务器和网络设备要监测，有没免费实用的。大家推荐下。</a>
					<div>
						问题描述 有没免费网管软件公司有几台服务器和网络设备要监测,有没免费实用的.大家推荐下. 解决方案 解决方案二:你应该把这个问题转到其它板块,顺便把没结贴的帖子结了.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlVRrp.html" rel="bookmark" class="title">Macromedia Captivate非官方简体中文版&lpar;capcn&period;exe&rpar;下载（2月3日发布）&lowbar;常用工具</a>
					<div>
						安装方法.使用.和官方一样.甚至比繁体中文版还要完整,每个用的到的内容都简体中文化了. 注意:本程序由Xray制作.原版程序的版权归Macromedia公司所有,简体中文资源版权归 Xray 和 风灵 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK9WVb.html" rel="bookmark" class="title">三种asp&period;net 删除数组重复字符串与数组值实例</a>
					<div>
						三种asp教程.net 删除数组重复字符串与数组值实例 我不会.net但今天还是找了三款删除数组重复字符串与数组值的asp.net教程实例函数,大概意思是把字符串分成数组或一个个拆分比较再去除重复的字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKWjXb.html" rel="bookmark" class="title">如何数据库中数据存到数组中</a>
					<div>
						问题描述 请问如何把数据库中的数据存到数组中,试了几种方法总是出错,希望能看一下demo片段 解决方案 1.你把从数据库中获取的list做个for循环,在循环的过程中,每次循环将list中一条数据插入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7PVNp.html" rel="bookmark" class="title">spring boot的pom&period;xml配置，正确生成jar包</a>
					<div>
						spring boot生成的jar包提示没有主清单属性. 需要在pom里加入配置. &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmV21b.html" rel="bookmark" class="title">C&num;扫描计算机端口</a>
					<div>
						using System; using System.Collections.Generic; using System.Text; using System.Net; using System.Ne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqnj6p.html" rel="bookmark" class="title">《Linux 高级程序设计（第三版）》&mdash;&mdash;1&period;3 部分常用工具简介</a>
					<div>
						1.3 部分常用工具简介 Linux 高级程序设计(第三版)1.3.1 tar打包器 如果要发布包含大量程序和文档的程序,则需对其进行打包压缩.在Shell命令行下,可以使用的文件压缩工具有:gzip ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeJOkM.html" rel="bookmark" class="title">途家网双十一初试天猫店成绩突出</a>
					<div>
						相比往年双11,火爆的旅游产品已经成为了今年双11的一大亮点,OTA巨头携程等的不断加入,更加让双11变数颇多.作为中高端度假公寓预订平台的途家网,初试天猫店成绩突出,途家天猫店双11当日再创纪录,跻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZB984z.html" rel="bookmark" class="title">JavaScript如何控制Session实现原理及代码</a>
					<div>
						看到这个题目,或许有人会提出疑问,JavaScript代表客户端,而Session代表的是服务器(不知道这样说大家是否能够理解). 先说一下需求,我在做一个权限管理的时候,需要在点击某个模块时,Ses ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDk0QLp.html" rel="bookmark" class="title">PHP类中的魔术方法（Magic Method）简明总结&lowbar;php实例</a>
					<div>
						1. __construct()和__destruct() 在实例被 创建/销毁 的时候被调用,都可以传递0个或多个参数. class A { function A() { echo &quot;bu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgE5e8z.html" rel="bookmark" class="title">Storage网盘赚钱  Storage网盘如何挣钱</a>
					<div>
						他人,只要有下载的,只要是通过链接形式的发布,有点想淘宝客推广的做法.     网盘推广方式     1.发帖   把链接发送出去,只要有需求的朋友看看到下载之后就会给你带来盈利.     2.seo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrgQep.html" rel="bookmark" class="title">ios-xcode运行程序报错，求大神指条路</a>
					<div>
						问题描述 xcode运行程序报错,求大神指条路 ld: cannot link directly with /Applications/Xcode.app/Contents/Developer/Pla ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNWJlp.html" rel="bookmark" class="title">echarts 散点图-echarts散点图原点自定义，而不是默认（0，0）</a>
					<div>
						问题描述 echarts散点图原点自定义,而不是默认(0,0) 自己定义散点图的坐标原点,而不是默认(0,0),比如定义成(50,50) 解决方案 定义grid,可以定义成{x:50,y2:50}					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QroaM.html" rel="bookmark" class="title">怎么在Eclipse下搭建Heritrix-1&period;14&period;0&quest;</a>
					<div>
						问题描述 怎么在Eclipse下搭建Heritrix-1.14.0! 解决方案 怎么在Eclipse下搭建Heritrix-1.14.01.在Eclipse下新建一个Java工程,命名Heritrix ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqgalKz.html" rel="bookmark" class="title">c语言-设一组初始记录关键字序列&lpar;5，2，6，3，8&rpar;，以第一个记录关键字5为基准进行一趟快</a>
					<div>
						问题描述 设一组初始记录关键字序列(5,2,6,3,8),以第一个记录关键字5为基准进行一趟快 设一组初始记录关键字序列(5,2,6,3,8),以第一个记录关键字5为基准进行一趟快 速排序的结果为(  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3YBmkp.html" rel="bookmark" class="title">VANCL预计第一季销售额超300&percnt;增长</a>
					<div>
						3月10日下午消息,网购服装品牌VANCL.COM(凡客诚品)发布消息称,根据其目前销售数字推测,2010年第一季度销售额同比将达到300%的增长,帆布鞋.T恤等春夏装新品的上市对业绩的提升起到了拉动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Y0wkz.html" rel="bookmark" class="title">Fortinet 携手中信国际电讯CPC在亚太地区扩展安全托管服务</a>
					<div>
						2016年5月26日,中国全球领先的高性能网络安全解决方案提供商Fortinet (NASDAQ: FTNT),在亚太区安全管理服务(MSS)方面,一直与中信国际电讯集团有限公司(1883)全资子公司 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQW8L8p.html" rel="bookmark" class="title">存储革命风暴：SCM为何将替代闪存？</a>
					<div>
						  随着企业不断发展基础设施和应用程序,他们逐渐发现存储是影响客户体验的主要瓶颈. 传统的存储I/O对于快速的处理器和网络来说是不够的.闪存存储以10倍于传统存储的性能而备受青睐,因此大部分关键应用都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVd5kKM.html" rel="bookmark" class="title">定义JavaScript二维数组采用定义数组的数组来实现&lowbar;基础知识</a>
					<div>
						1. javaScript没有提供直接定义二维数组的方法,但可以使用定义数组的数组来定义JavaScript二维数组:例如定义一个 4X3二维数组a可以采用如下方法: var a=new Array( ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
